/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2011
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2011
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file resizeExpandByResized.c
 * A datatype implementation test.
 * Contains no errors.
 *
 * @author Joachim Protze
 */

#include "datatypetest.h"


int main (int argc, char** argv)
{

    MPI_Init(&argc,&argv);

    MPI_Datatype        contitype, resizedtype;

    MPI_Type_contiguous (5, MPI_INT, &contitype);
    MPI_Type_create_resized (contitype , -4, 28, &resizedtype);

    // call the real test - this is a macro, that directs to the specific test
    datatypeTest(resizedtype);

    MPI_Type_free(&resizedtype);
    MPI_Type_free(&contitype);

    MPI_Finalize ();

    return 0;
}
