/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2011
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2011
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file simpleSubarray.c
 * A datatype implementation test.
 * Contains no errors.
 *
 * @author Joachim Protze
 */

#include "datatypetest.h"


int main (int argc, char** argv)
{

    MPI_Init(&argc,&argv);

    MPI_Datatype        subarraytype;

    int sizes[] = {5,5,5};
    int subsizes[] = {2,2,2};
    int starts[] = {1,2,3};

    MPI_Type_create_subarray (3, sizes, subsizes, starts, MPI_ORDER_C, MPI_INT, &subarraytype);

    // call the real test - this is a macro, that directs to the specific test
    datatypeTest(subarraytype);

    MPI_Type_free(&subarraytype);

    MPI_Finalize ();

    return 0;
}
