/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2011
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2011
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file example_4_4.c
 * A must datatype test.
 * Contains no errors.
 *
 * @author Joachim Protze
 */

#include "datatypeTest.h"

int main (int argc, char** argv)
{

    int fType;
    MPI_Init(&argc,&argv);

    MPI_Datatype        oldtype, newtype;
    int                 blocklens[2] = {1,1};
    MPI_Aint            displs[2] = {0,8};
    MPI_Datatype        types[2] = {MPI_DOUBLE, MPI_CHAR};

    MPI_Type_struct (2, blocklens, displs, types, &oldtype);
    test_type (oldtype);


    MPI_Type_vector (3, 1, -2, oldtype, &newtype);
    test_type (newtype);

    MPI_Finalize ();

    return 0;
}
