#!/bin/sh

##
# @file config.sh
# this script is a config file for a complete MUST/GTI check
#
# Description:
# This script sets variables that are needed to run a complete test
#
#  @date 22.03.2011
#  @author Mathias Korepkat
##

#################
# SET Variables
#################

##
# Warning this directory will be deleted after running the test!
##
INSTALL_DIR=/home/mk/workspace/minigti/BUILD/myTest

PNMPI_FILE='http://rcswww.zih.tu-dresden.de/~hilbrich/pnmpi.tar'

CMAKE_PNMPI="-DCMAKE_INSTALL_PREFIX=$INSTALL_DIR/pnmpi/install"

CMAKE_GTI="-DCMAKE_INSTALL_PREFIX=$INSTALL_DIR/gti/install"
CMAKE_GTI="$CMAKE_GTI -DPnMPI_HOME=$INSTALL_DIR/pnmpi/install"
CMAKE_GTI="$CMAKE_GTI -DENABLE_TESTS=ON"

CMAKE_MUST="-DCMAKE_INSTALL_PREFIX=$INSTALL_DIR/must/install"
CMAKE_MUST="$CMAKE_MUST -DGTI_HOME=$INSTALL_DIR/gti/install"
CMAKE_MUST="$CMAKE_MUST -DENABLE_TESTS=ON"
